/*     
 * $RCSfile: xk_arch.h,v $
 *
 * x-kernel v3.3
 *
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 *
 * HISTORY
 * $Log: xk_arch.h,v $
 * Revision 1.3  1996/02/01  15:19:28  slm
 * Updated copyright and version.
 *
 * Revision 1.2  1995/08/28  16:13:36  acb
 * Initial revision for x3.3
 *
 * Revision 1.1  1994/10/26  20:20:51  hkaram
 * Initial revision
 */
#ifndef xk_arch_h
#define xk_arch_h
/*
 * For use when length matters (e.g., protocol header fields).
 */
#define xk_int8		char
#define xk_int16	short
#define xk_int32	int
#define xk_int64	long

#define xk_u_int8	unsigned char
#define xk_u_int16	unsigned short
#define xk_u_int32	unsigned int
#define xk_u_int64	unsigned long

/*
 * Return TRUE if address "a" is suitably aligned to hold an address.
 */
#define LONG_ALIGNED(a)	(((u_long)(a) & 0x7) == 0)

#define XK_INT32_HEX_FORMAT	"%x"
#define XK_INT32_DEC_FORMAT	"%d"

#endif /* xk_arch_h */
