/*
 * $RCSfile: modeldep.h,v $
 *
 * x-kernel v3.3 - IRIX port
 *
 * Copyright (c) 1993 Massachusetts Board of Regents
 *
 * $Log: modeldep.h,v $
 * Revision 1.2  1996/01/30 20:51:19  slm
 * Updated copyright and version.
 *
 * Revision 1.1  1995/07/29  02:40:49  slm
 * Initial revision
 *
 * Revision 1.1.2.1  1994/11/12  19:10:43  hkaram
 * New branch
 *
 * Revision 1.1  1994/03/15  18:09:33  umass
 * Initial revision
 *
 * Machine, Model and System Software dependent parameters for the
 * SGI IRIX port.
 * -------------------------------------------------------------------------
 * We keep track of vendor release numbers for the OS as well as  FDDIXpress
 * since there are bug fix issues to keep track of.
 * 
 * Hardware types that we can test on:
 * IP12          Indigo 33 MHz R3000A
 * IP20          Indigo 100 MHz R4000SC
 * IP5/IP6/IP7   POWER Series 4D/{2xx,3xx,4xx} (25 MHz/33MHz/40 MHz) R3000
 * IP19          Onyx/Challenge 100 MHz R4400MC
 * -------------------------------------------------------------------------
 */

/*
 * Processor board types
 */

#define SGI_INDIGO_R3000        12
#define SGI_INDIGO_R4000        20
#define SGI_POWER4D             7
#define SGI_CHALLENGE           19

/*
 * FDDI Network Interfaces
 */

#define SGI_FDDI_VME            "ipg0"
#define SGI_FDDI_GIO32          "xpi0"

/*
 * Ethernet Network Interfaces 
 */

#define SGI_IEEE8023_POWER4D    "et0" 
#define SGI_IEEE8023_CHALLENGE  "et0" 
#define SGI_IEEE8023_ECLIPSE    "ec0"

/*
 * IRIX release levels that we are familiar with
 */

#define SGI_IRIX_405            "4.0.5"
#define SGI_IRIX_405H           "4.0.5H"
#define SGI_IRIX_501            "5.0.1"
#define SGI_IRIX_511            "5.1.1"
#define SGI_IRIX_5111           "5.1.1.1"
#define SGI_IRIX_5112           "5.1.1.2"

#define _XK_SYS_NMLN  257  /* 257 needed for IRIX5 compat with sys/utsname.h */

typedef struct
{
  unsigned int hardware_type;
  char os_rev_level[_XK_SYS_NMLN];
  char ethernet_if_name[_XK_SYS_NMLN];
  char fddi_if_name[_XK_SYS_NMLN];
} IRIX_Machine_Info;

#if defined(__STDC__) || defined(__GNUC__)
void GetSGIMachineInfo(IRIX_Machine_Info *);
#endif
